## mympd 10.1.1

=== CMakeLists.txt ===
# SPDX-License-Identifier: GPL-3.0-or-later
# myMPD (c) 2018-2022 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/mympd

# minimal cmake version needed for new option handling
cmake_minimum_required(VERSION 3.13 FATAL_ERROR)
cmake_policy(SET CMP0003 NEW)

# myMPD is written in C
# supported compilers: gcc, clang
project(mympd
  VERSION 10.1.1
  LANGUAGES C
)

# output binaries in bin directory
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

message("Cmake version: ${CMAKE_VERSION}")
message("Cmake src dir: ${PROJECT_SOURCE_DIR}")
message("Cmake build dir: ${CMAKE_CURRENT_BINARY_DIR}")
message("Cmake build type: ${CMAKE_BUILD_TYPE}")
message("Compiler: ${CMAKE_C_COMPILER_ID} ${CMAKE_C_COMPILER_VERSION}")
message("CMAKE_C_FLAGS: ${CMAKE_C_FLAGS}")
message("CMAKE_EXE_LINKER_FLAGS: ${CMAKE_EXE_LINKER_FLAGS}")

# reset cmake default Release and Debug flags
set(CMAKE_C_FLAGS_RELEASE "")
set(CMAKE_C_FLAGS_DEBUG "")

# default is to deliver the assets from htdocs for Debug
# and embedded assets for all other build types
if(NOT DEFINED MYMPD_EMBEDDED_ASSETS)
  if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(MYMPD_EMBEDDED_ASSETS "OFF")
  else()
    set(MYMPD_EMBEDDED_ASSETS "ON")
  endif()
endif()

# set debug define for source
if(NOT DEFINED MYMPD_DEBUG)
  if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(MYMPD_DEBUG "ON")
  else()
    set(MYMPD_DEBUG "OFF")
  endif()
endif()

# available options
option(MYMPD_DEBUG "Enables myMPD debug mode, default OFF, ON for Debug" "OFF")
option(MYMPD_EMBEDDED_ASSETS "Embed assets in binary, default ON, OFF for Debug" "ON")
option(MYMPD_ENABLE_FLAC "Enables flac support, default ON" "ON")
option(MYMPD_ENABLE_IPV6 "Enables IPv6, default ON" "ON")
option(MYMPD_ENABLE_LIBASAN "Enables build with libasan, default OFF" "OFF")
option(MYMPD_ENABLE_LIBID3TAG "Enables libid3tag support, default ON" "ON")
option(MYMPD_ENABLE_LUA "Enables lua support, default ON" "ON")
option(MYMPD_ENABLE_SSL "Enables OpenSSL support, default ON" "ON")
option(MYMPD_MANPAGES "Creates and installs manpages" "ON")
option(MYMPD_MINIMAL "Enables minimal myMPD build, disables all MYMPD_ENABLE_* flags" "OFF")
option(MYMPD_STRIP_BINARY "Enables stripping the binaries for Release, default ON" "ON")

if(MYMPD_MINIMAL)
  set(MYMPD_ENABLE_FLAC "OFF")
  set(MYMPD_ENABLE_IPV6 "OFF")
  set(MYMPD_ENABLE_LUA "OFF")
  set(MYMPD_ENABLE_LIBID3TAG "OFF")
  set(MYMPD_ENABLE_SSL "OFF")
endif()

# cmake modules
include(GNUInstallDirs)
include(CheckCSourceCompiles)
include(CheckCCompilerFlag)

# custom cmake modules
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${PROJECT_SOURCE_DIR}/cmake/")

# calculate paths
if(CMAKE_INSTALL_PREFIX STREQUAL "/usr")
  set(SUBDIR "/${PROJECT_NAME}")
  set(SUBDIRLIB "/lib")
  set(SUBDIRCACHE "/cache")
else()
  # for install in /opt
  set(SUBDIR "")
  set(SUBDIRLIB "")
  set(SUBDIRCACHE "")
endif()

message("Executables in: ${CMAKE_INSTALL_FULL_BINDIR}")

if(CMAKE_INSTALL_PREFIX STREQUAL "/usr/local")
  set(MYMPD_WORK_DIR "/${CMAKE_INSTALL_LOCALSTATEDIR}${SUBDIRLIB}${SUBDIR}")
else()
  set(MYMPD_WORK_DIR "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}${SUBDIRLIB}${SUBDIR}")
endif()
message("Workdir: ${MYMPD_WORK_DIR}")

if(CMAKE_INSTALL_PREFIX STREQUAL "/usr/local")
  set(MYMPD_CACHE_DIR "/${CMAKE_INSTALL_LOCALSTATEDIR}${SUBDIRCACHE}${SUBDIR}")
else()
  set(MYMPD_CACHE_DIR "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}${SUBDIRCACHE}${SUBDIR}")
endif()
message("Cachedir: ${MYMPD_CACHE_DIR}")

if(MYMPD_EMBEDDED_ASSETS)
  message("Embedding assets in binary")
  set(MYMPD_DOC_ROOT "${MYMPD_WORK_DIR}/empty")
  set(MYMPD_LUALIBS_PATH "")
  set(ENV{MYMPD_BUILDDIR} "${CMAKE_CURRENT_BINARY_DIR}")
  execute_process(COMMAND "${PROJECT_SOURCE_DIR}/build.sh" createassets)
  # remove object files with embedded assets
  file(REMOVE "${CMAKE_CURRENT_BINARY_DIR}/CMakeFiles/mympd.dir/src/web_server/utility.c.o")
  file(REMOVE "${CMAKE_CURRENT_BINARY_DIR}/CMakeFiles/mympd.dir/src/mympd_api/scripts.c.o")
else()
  message("Serving assets from filesystem")
  set(MYMPD_DOC_ROOT "${PROJECT_SOURCE_DIR}/htdocs")
  set(MYMPD_LUALIBS_PATH "${PROJECT_SOURCE_DIR}/contrib/lualibs")
  set(ENV{MYMPD_BUILDDIR} "${CMAKE_CURRENT_BINARY_DIR}")
  execute_process(COMMAND "${PROJECT_SOURCE_DIR}/build.sh" copyassets)
endif()
message("Document root: ${MYMPD_DOC_ROOT}")

# required dependencies
find_package(Threads REQUIRED)
find_package(PCRE2 REQUIRED)
find_library(MATH_LIB m REQUIRED)

# optional dependencies
if(MYMPD_ENABLE_SSL)
  message("Searching for openssl")
  find_package(OpenSSL)
  if(OPENSSL_FOUND)
    if(NOT OPENSSL_VERSION VERSION_GREATER_EQUAL "1.1.0")
      message("OpenSSL is disabled because a version lower than 1.1.0 was found")
      set(MYMPD_ENABLE_SSL "OFF")
    endif()
  else()
    message("OpenSSL is disabled because it was not found")
    set(MYMPD_ENABLE_SSL "OFF")
  endif()
else()
  message("OpenSSL is disabled by user")
endif()

if(MYMPD_ENABLE_LIBID3TAG)
  message("Searching for libid3tag")
  find_package(LIBID3TAG)
  if(NOT LIBID3TAG_FOUND)
    message("Libid3tag is disabled because it was not found")
    set(MYMPD_ENABLE_LIBID3TAG "OFF")
  endif()
else()
  message("Libid3tag is disabled by user")
endif()

if(MYMPD_ENABLE_FLAC)
  message("Searching for flac")
  find_package(FLAC)
  if(NOT FLAC_FOUND)
    message("Flac is disabled because it was not found")
    set(MYMPD_ENABLE_FLAC "OFF")
  endif()
else()
  message("Flac is disabled by user")
endif()

if(MYMPD_ENABLE_LUA)
  if(EXISTS "/etc/alpine-release")
    set(ENV{LUA_DIR} "/usr/lib/lua5.4")
  endif()
  message("Searching for lua")
  find_package(Lua)
  if(LUA_FOUND)
    if(NOT LUA_VERSION_STRING VERSION_GREATER_EQUAL "5.3.0")
      message("Lua is disabled because a version lower than 5.3.0 was found")
      set(MYMPD_ENABLE_LUA "OFF")
    endif()
  else()
    message("Lua is disabled because it was not found")
    set(MYMPD_ENABLE_LUA "OFF")
  endif()
else()
  message("Lua is disabled by user")
endif()

# translation files
if(MYMPD_EMBEDDED_ASSETS)
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/de-DE.json.gz")
    set(I18N_de_DE "ON")
  endif()
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/en-US.json.gz")
    set(I18N_en_US "ON")
  endif()
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/es-ES.json.gz")
    set(I18N_es_ES "ON")
  endif()
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/es-VE.json.gz")
    set(I18N_es_VE "ON")
  endif()
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/fi-FI.json.gz")
    set(I18N_fi_FI "ON")
  endif()
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/fr-FR.json.gz")
    set(I18N_fr_FR "ON")
  endif()
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/it-IT.json.gz")
    set(I18N_it_IT "ON")
  endif()
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/ja-JP.json.gz")
    set(I18N_ja_JP "ON")
  endif()
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/ko-KR.json.gz")
    set(I18N_ko_KR "ON")
  endif()
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/nl-NL.json.gz")
    set(I18N_nl_NL "ON")
  endif()
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/zh-CN.json.gz")
    set(I18N_zh_CN "ON")
  endif()
endif()

# configure some files - version and path information
configure_file(src/compile_time.h.in "${PROJECT_BINARY_DIR}/compile_time.h")
configure_file(cmake/CopyConfig.cmake.in cmake/CopyConfig.cmake @ONLY)
configure_file(contrib/initscripts/mympd.service.in contrib/initscripts/mympd.service @ONLY)
configure_file(contrib/initscripts/mympd.sysVinit.in contrib/initscripts/mympd.sysVinit @ONLY)
configure_file(contrib/initscripts/mympd.openrc.in contrib/initscripts/mympd.openrc @ONLY)

if(CMAKE_BUILD_TYPE MATCHES "(Release|Debug)")
  # set strict global compile flags
  add_compile_options(
    "-fdata-sections"
    "-ffunction-sections"
    "-fstack-protector-strong"
    "-pedantic"
    "-Wall"
    "-Werror"
    "-Wextra"
    "-Wformat"
    "-Wformat-security"
    "-Winit-self"
    "-Wmissing-include-dirs"
    "-Wnested-externs"
    "-Wold-style-definition"
    "-Wredundant-decls"
    "-Wshadow"
    "-Wsign-compare"
    "-Wstrict-prototypes"
    "-Wundef"
    "-Wuninitialized"
    "-Wunused-parameter"
    "-Wvla"
    "-Wwrite-strings"
  )

  # check for supported compiler flags
  foreach(FLAG IN ITEMS "-std=gnu17" "-fstack-clash-protection" "-fcf-protection" "-fno-plt")
    message("Checking for compiler flag ${FLAG}")
    unset(COMPILER_SUPPORTS_FLAG CACHE)
    unset(COMPILER_SUPPORTS_FLAG)
    check_c_compiler_flag("${FLAG}" COMPILER_SUPPORTS_FLAG)
    if(COMPILER_SUPPORTS_FLAG)
      add_compile_options("${FLAG}")
    endif()
  endforeach()

  if(NOT MYMPD_ENABLE_LIBASAN)
    #incompatible with libasan
    add_compile_options("-D_FORTIFY_SOURCE=2")
  endif()
else()
  # if CMAKE_BUILD_TYPE is neither Release nor Debug,
  # do not alter compile options
endif()

# libasan memory checker
# https://github.com/google/sanitizers/wiki/AddressSanitizer#faq
if(MYMPD_ENABLE_LIBASAN)
  message("Compiling with libasan")
  set(LIBASAN_FLAGS
    "-fsanitize=address"
    "-fsanitize=alignment"
    "-fsanitize=bool"
    "-fsanitize=bounds"
    "-fsanitize=bounds-strict"
    "-fsanitize=enum"
    "-fsanitize=float-cast-overflow"
    "-fsanitize=float-divide-by-zero"
    "-fsanitize=integer-divide-by-zero"
    "-fsanitize=nonnull-attribute"
    "-fsanitize=null"
    "-fsanitize=object-size"
    "-fsanitize=return"
    "-fsanitize=returns-nonnull-attribute"
    "-fsanitize=shift"
    "-fsanitize=signed-integer-overflow"
    "-fsanitize=undefined"
    "-fsanitize=unreachable"
    "-fsanitize=vla-bound"
    "-fsanitize=vptr"
  )
  add_compile_options(
    ${LIBASAN_FLAGS}
    "-fno-omit-frame-pointer"
  )
endif()

if(CMAKE_BUILD_TYPE STREQUAL "Release")
  add_compile_options(
    "-fPIE"
    "-O2"
    "-DNDEBUG"
  )
  if(NOT MYMPD_STRIP_BINARY)
    message("Generating binary with debug symbols")
    add_compile_options("-g")
  endif()
elseif(CMAKE_BUILD_TYPE STREQUAL "Debug")
  add_compile_options(
    "-ggdb"
    "-Og"
  )
else()
  # if CMAKE_BUILD_TYPE is neither Release nor Debug,
  # do not alter compile options
endif()

# linker flags
if(MYMPD_ENABLE_LIBASAN)
  add_link_options(${LIBASAN_FLAGS})
endif()

if(CMAKE_BUILD_TYPE STREQUAL "Release")
  add_link_options(
    "-pie"
    "-Wl,-z,relro,-z,now,--gc-sections,--as-needed"
  )
  if(MYMPD_STRIP_BINARY)
    message("Generating stripped binary")
    add_link_options("-s")
  endif()
else()
  # if CMAKE_BUILD_TYPE is neither Release nor Debug,
  # do not alter link options
endif()

# distributed libraries
add_subdirectory("dist")

# the main mympd target
add_subdirectory("src")

# command line utilities
add_subdirectory("cli_tools")

# link all together
target_link_libraries(mympd
  libmpdclient
  mjson
  mongoose
  rax
  sds
  tinymt
  ${CMAKE_THREAD_LIBS_INIT}
  ${MATH_LIB}
  ${PCRE2_LIBRARIES}
)

# link optional dependencies
if(OPENSSL_FOUND)
  target_link_libraries(mympd ${OPENSSL_LIBRARIES})
endif()
if(LIBID3TAG_FOUND)
  target_link_libraries(mympd ${LIBID3TAG_LIBRARIES})
endif()
if(FLAC_FOUND)
  target_link_libraries(mympd ${FLAC_LIBRARIES})
endif()
if(LUA_FOUND)
  target_link_libraries(mympd ${LUA_LIBRARIES})
endif()

# install
install(TARGETS mympd DESTINATION ${CMAKE_INSTALL_FULL_BINDIR})
install(SCRIPT ${CMAKE_CURRENT_BINARY_DIR}/cmake/CopyConfig.cmake)

=== cli_tools/CMakeLists.txt ===
if(LUA_FOUND)
  add_subdirectory("mympd-script")
endif()

=== dist/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-3.0-or-later
# myMPD (c) 2018-2022 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/mympd

add_subdirectory(libmpdclient)
add_subdirectory(mjson)
add_subdirectory(mongoose)
add_subdirectory(rax)
add_subdirectory(sds)
add_subdirectory(tinymt)

=== src/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-3.0-or-later
# myMPD (c) 2018-2022 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/mympd

add_executable(mympd "")

if(CMAKE_BUILD_TYPE MATCHES "(Release|Debug)")
  target_compile_options(mympd
    PRIVATE
      "-Wconversion"
      "-Wformat=2"
  )
endif()

target_include_directories(mympd
  PRIVATE 
    ${PROJECT_BINARY_DIR}
    ${PROJECT_SOURCE_DIR}
)

target_include_directories(mympd SYSTEM PRIVATE ${PCRE2_INCLUDE_DIRS})

if(MYMPD_ENABLE_LUA)
  target_include_directories(mympd SYSTEM PRIVATE ${LUA_INCLUDE_DIR})
endif()

if(MYMPD_ENABLE_FLAC)
  target_include_directories(mympd SYSTEM PRIVATE ${FLAC_INCLUDE_DIRS})
endif()

if(MYMPD_ENABLE_LIBID3TAG)
  target_include_directories(mympd SYSTEM PRIVATE ${LIBID3TAG_INCLUDE_DIRS})
endif()

if(MYMPD_ENABLE_SSL)
  target_include_directories(mympd SYSTEM PRIVATE ${OPENSSL_INCLUDE_DIR})
  target_sources(mympd PRIVATE lib/cert.c)
endif()

target_sources(mympd PRIVATE
  main.c
  lib/album_cache.c
  lib/api.c
  lib/config.c
  lib/covercache.c
  lib/filehandler.c
  lib/handle_options.c
  lib/http_client.c
  lib/jsonrpc.c
  lib/list.c
  lib/log.c
  lib/lua_mympd_state.c
  lib/m3u.c
  lib/mimetype.c
  lib/pin.c
  lib/msg_queue.c
  lib/mympd_state.c
  lib/random.c
  lib/rax_extras.c
  lib/sds_extras.c
  lib/smartpls.c
  lib/state_files.c
  lib/sticker_cache.c
  lib/utility.c
  lib/validate.c
  mpd_client/autoconf.c
  mpd_client/connection.c
  mpd_client/errorhandler.c
  mpd_client/features.c
  mpd_client/idle.c
  mpd_client/jukebox.c
  mpd_client/partitions.c
  mpd_client/playlists.c
  mpd_client/search.c
  mpd_client/search_local.c
  mpd_client/tags.c
  mpd_client/volume.c
  mpd_worker/mpd_worker.c
  mpd_worker/api.c
  mpd_worker/cache.c
  mpd_worker/smartpls.c
  mpd_worker/state.c
  mympd_api/mympd_api.c
  mympd_api/albumart.c
  mympd_api/browse.c
  mympd_api/extra_media.c
  mympd_api/filesystem.c
  mympd_api/home.c
  mympd_api/last_played.c
  mympd_api/lyrics.c
  mympd_api/mounts.c
  mympd_api/mympd_api_handler.c
  mympd_api/outputs.c
  mympd_api/partitions.c
  mympd_api/pictures.c
  mympd_api/playlists.c
  mympd_api/queue.c
  mympd_api/scripts.c
  mympd_api/settings.c
  mympd_api/smartpls.c
  mympd_api/song.c
  mympd_api/stats.c
  mympd_api/status.c
  mympd_api/sticker.c
  mympd_api/timer.c
  mympd_api/timer_handlers.c
  mympd_api/trigger.c
  mympd_api/volume.c
  mympd_api/webradios.c
  web_server/web_server.c
  web_server/albumart.c
  web_server/request_handler.c
  web_server/proxy.c
  web_server/radiobrowser.c
  web_server/sessions.c
  web_server/tagart.c
  web_server/utility.c
  web_server/webradiodb.c
)

=== test/CMakeLists.txt ===
#
# SPDX-License-Identifier: GPL-3.0-or-later
# myMPD (c) 2018-2022 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/mympd
#

cmake_minimum_required(VERSION 3.4)

project(test C)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${PROJECT_SOURCE_DIR}/../cmake/")

find_package(Threads REQUIRED)
find_library(MATH_LIB m REQUIRED)
find_package(OpenSSL REQUIRED)
find_package(PCRE2 REQUIRED)
find_package(LIBID3TAG REQUIRED)
find_package(FLAC REQUIRED)

set(TEST_SOURCES
  ../dist/mjson/mjson.c
  ../dist/mongoose/mongoose.c
  ../dist/rax/rax.c
  ../dist/sds/sds.c
  ../dist/tinymt/tinymt32.c
  ../src/lib/album_cache.c
  ../src/lib/api.c
  ../src/lib/cert.c
  ../src/lib/filehandler.c
  ../src/lib/http_client.c
  ../src/lib/jsonrpc.c
  ../src/lib/list.c
  ../src/lib/log.c
  ../src/lib/lua_mympd_state.c
  ../src/lib/m3u.c
  ../src/lib/mimetype.c
  ../src/lib/msg_queue.c
  ../src/lib/mympd_state.c
  ../src/lib/random.c
  ../src/lib/sds_extras.c
  ../src/lib/state_files.c
  ../src/lib/sticker_cache.c
  ../src/lib/utility.c
  ../src/lib/validate.c
  ../src/mpd_client/errorhandler.c
  ../src/mpd_client/search.c
  ../src/mpd_client/search_local.c
  ../src/mpd_client/tags.c
  ../src/mpd_client/jukebox.c
  ../src/mpd_client/volume.c
  ../src/mympd_api/extra_media.c
  ../src/mympd_api/home.c
  ../src/mympd_api/last_played.c
  ../src/mympd_api/lyrics.c
  ../src/mympd_api/status.c
  ../src/mympd_api/sticker.c
  ../src/mympd_api/timer.c
  ../src/mympd_api/timer_handlers.c
  ../src/mympd_api/trigger.c
  ../src/mympd_api/queue.c
  ../src/mympd_api/webradios.c
  main.c
  tests/test_api.c
  tests/test_cert.c
  tests/test_http_client.c
  tests/test_jsonrpc.c
  tests/test_list.c
  tests/test_lyrics.c
  tests/test_m3u.c
  tests/test_mpd_client_tags.c
  tests/test_mimetype.c
  tests/test_mympd_queue.c
  tests/test_radix_sort.c
  tests/test_random.c
  tests/test_sds_extras.c
  tests/test_state_files.c
  tests/test_timer.c
  tests/test_utility.c
  tests/test_validate.c
)

set(LIBMPDCLIENT_SOURCES
  ../dist/libmpdclient/src/albumart.c
  ../dist/libmpdclient/src/async.c
  ../dist/libmpdclient/src/audio_format.c
  ../dist/libmpdclient/src/binary.c
  ../dist/libmpdclient/src/capabilities.c
  ../dist/libmpdclient/src/cmessage.c
  ../dist/libmpdclient/src/cmount.c
  ../dist/libmpdclient/src/cneighbor.c
  ../dist/libmpdclient/src/connection.c
  ../dist/libmpdclient/src/coutput.c
  ../dist/libmpdclient/src/cpartition.c
  ../dist/libmpdclient/src/cplaylist.c
  ../dist/libmpdclient/src/cstats.c
  ../dist/libmpdclient/src/cstatus.c
  ../dist/libmpdclient/src/database.c
  ../dist/libmpdclient/src/directory.c
  ../dist/libmpdclient/src/entity.c
  ../dist/libmpdclient/src/error.c
  ../dist/libmpdclient/src/fd_util.c
  ../dist/libmpdclient/src/fingerprint.c
  ../dist/libmpdclient/src/idle.c
  ../dist/libmpdclient/src/ierror.c
  ../dist/libmpdclient/src/iso8601.c
  ../dist/libmpdclient/src/kvlist.c
  ../dist/libmpdclient/src/list.c
  ../dist/libmpdclient/src/message.c
  ../dist/libmpdclient/src/mixer.c
  ../dist/libmpdclient/src/mount.c
  ../dist/libmpdclient/src/neighbor.c
  ../dist/libmpdclient/src/output.c
  ../dist/libmpdclient/src/parser.c
  ../dist/libmpdclient/src/partition.c
  ../dist/libmpdclient/src/password.c
  ../dist/libmpdclient/src/player.c
  ../dist/libmpdclient/src/playlist.c
  ../dist/libmpdclient/src/position.c
  ../dist/libmpdclient/src/queue.c
  ../dist/libmpdclient/src/quote.c
  ../dist/libmpdclient/src/replay_gain.c
  ../dist/libmpdclient/src/rdirectory.c
  ../dist/libmpdclient/src/readpicture.c
  ../dist/libmpdclient/src/recv.c
  ../dist/libmpdclient/src/replay_gain.c
  ../dist/libmpdclient/src/resolver.c
  ../dist/libmpdclient/src/response.c
  ../dist/libmpdclient/src/rplaylist.c
  ../dist/libmpdclient/src/run.c
  ../dist/libmpdclient/src/search.c
  ../dist/libmpdclient/src/send.c
  ../dist/libmpdclient/src/settings.c
  ../dist/libmpdclient/src/socket.c
  ../dist/libmpdclient/src/song.c
  ../dist/libmpdclient/src/stats.c
  ../dist/libmpdclient/src/status.c
  ../dist/libmpdclient/src/sticker.c
  ../dist/libmpdclient/src/sync.c
  ../dist/libmpdclient/src/tag.c
)

set(LIBASAN_FLAGS "-fsanitize=address \
  -fsanitize=undefined -fsanitize=shift -fsanitize=integer-divide-by-zero -fsanitize=unreachable -fsanitize=vla-bound \
  -fsanitize=null -fsanitize=return -fsanitize=signed-integer-overflow -fsanitize=bounds -fsanitize=bounds-strict \
  -fsanitize=alignment -fsanitize=object-size -fsanitize=float-divide-by-zero -fsanitize=float-cast-overflow \
  -fsanitize=nonnull-attribute -fsanitize=returns-nonnull-attribute -fsanitize=bool -fsanitize=enum -fsanitize=vptr \
  -static-libasan")

#set mongoose feature flags
set(MONGOOSE_FLAGS "-DMG_ENABLE_OPENSSL=1 -DMG_ENABLE_DIRECTORY_LISTING=1 -DMG_ENABLE_SSI=0")
if(ENABLE_IPV6)
  message("IPv6 is enabled")
  set(MONGOOSE_FLAGS "${MONGOOSE_FLAGS} -DMG_ENABLE_IPV6=1")
else()
  message("IPv6 is disabled")
endif()
#set mjson feature flags
set(MJSON_FLAGS "-D MJSON_ENABLE_PRINT=0 -D MJSON_ENABLE_BASE64=0 -D MJSON_ENABLE_RPC=0 \
  -D MJSON_ENABLE_PRETTY=0 -D MJSON_ENABLE_MERGE=0")

#disabled for compatibility with tests
set(UTEST_FLAGS "-Wno-unused-function -Wno-redundant-decls")

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector-strong -D_FORTIFY_SOURCE=2 \
  -ffunction-sections -fdata-sections -Wall -Werror -Wvla -Winit-self -Wuninitialized \
  -Werror=array-bounds -Wextra -pedantic -Wunused-parameter -Wshadow -Wwrite-strings \
  -Wformat=2 -Wstrict-prototypes -Wold-style-definition -Wnested-externs \
  -Wmissing-include-dirs -Wundef -Wformat-nonliteral -Wsign-compare \
  -Wno-stringop-overread -Wno-array-bounds \
  ${UTEST_FLAGS} ${LIBASAN_FLAGS} ${MONGOOSE_FLAGS} ${MJSON_FLAGS}")

# debug flags
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ggdb -Og")

#relax some compiler settings for dist sources
#compiler flags for mongoose
#-Wno-stringop-overflow: gcc 11.2.0 bug
#-Wno-stringop-overread: gcc 12.0.1 bug
set_property(SOURCE ../dist/mongoose/mongoose.c PROPERTY COMPILE_FLAGS "-Wno-format-nonliteral -Wno-conversion \
  -Wno-stringop-overflow")
#compiler flags for mjson
set_property(SOURCE ../dist/mjson/mjson.c PROPERTY COMPILE_FLAGS "-Wno-conversion")
#compiler flags for rax
#-Wno-use-after-free: gcc 12.0.1 error
set_property(SOURCE ../dist/rax/rax.c PROPERTY COMPILE_FLAGS "-Wno-format-nonliteral -Wno-conversion \
 -Wno-shadow -Wno-discarded-qualifiers -Wno-incompatible-pointer-types-discards-qualifiers -Wno-use-after-free")
#compiler flags for sds
#-Wno-stringop-overflow: gcc 11.2.0 bug
set_property(SOURCE ../dist/sds/sds.c PROPERTY COMPILE_FLAGS "-Wno-format-nonliteral -Wno-stringop-overflow -Wno-conversion")
#compiler flags for libmpdclient
set_property(SOURCE ${LIBMPDCLIENT_SOURCES} PROPERTY COMPILE_FLAGS "-Wno-conversion")

set(MYMPD_ENABLE_FLAC "ON")
set(MYMPD_ENABLE_LIBID3TAG "ON")
configure_file(../src/compile_time.h.in ${PROJECT_BINARY_DIR}/compile_time.h)

include_directories(${PROJECT_BINARY_DIR} ${PROJECT_SOURCE_DIR} ${PROJECT_SOURCE_DIR}/.. ../dist/libmpdclient/include)

include(CheckCSourceCompiles)

add_executable(test ${TEST_SOURCES} ${LIBMPDCLIENT_SOURCES})
target_link_libraries(test ${CMAKE_THREAD_LIBS_INIT})
target_link_libraries(test ${MATH_LIB})
target_link_libraries(test ${OPENSSL_LIBRARIES})
target_link_libraries(test ${PCRE2_LIBRARIES})
target_link_libraries(test ${LIBID3TAG_LIBRARIES})
target_link_libraries(test ${FLAC_LIBRARIES})

=== cli_tools/mympd-script/CMakeLists.txt ===
#
# SPDX-License-Identifier: GPL-3.0-or-later
# myMPD (c) 2018-2022 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/mympd
#

add_executable(mympd-script "")

target_include_directories(mympd-script
  PRIVATE
    ${PROJECT_BINARY_DIR}
    ${PROJECT_SOURCE_DIR}
)

target_sources(mympd-script
  PRIVATE
    mympd-script.c
    ../log.c
    ../../src/lib/filehandler.c
    ../../src/lib/sds_extras.c
    ../../src/lib/http_client.c
)

target_link_libraries(mympd-script
  sds
  mongoose
)

if(OPENSSL_FOUND)
  target_link_libraries(mympd-script ${OPENSSL_LIBRARIES})
endif()

install(TARGETS mympd-script DESTINATION ${CMAKE_INSTALL_FULL_BINDIR})

=== dist/libmpdclient/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-3.0-or-later
# myMPD (c) 2018-2022 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/mympd

add_library(libmpdclient "")

target_include_directories(libmpdclient PUBLIC include)

target_sources(libmpdclient
  PRIVATE
    src/albumart.c
    src/async.c
    src/audio_format.c
    src/binary.c
    src/capabilities.c
    src/cmessage.c
    src/cmount.c
    src/cneighbor.c
    src/connection.c
    src/coutput.c
    src/cpartition.c
    src/cplaylist.c
    src/cstats.c
    src/cstatus.c
    src/database.c
    src/directory.c
    src/entity.c
    src/error.c
    src/fd_util.c
    src/fingerprint.c
    src/idle.c
    src/ierror.c
    src/iso8601.c
    src/kvlist.c
    src/list.c
    src/message.c
    src/mixer.c
    src/mount.c
    src/neighbor.c
    src/output.c
    src/parser.c
    src/partition.c
    src/password.c
    src/player.c
    src/playlist.c
    src/position.c
    src/queue.c
    src/quote.c
    src/replay_gain.c
    src/rdirectory.c
    src/readpicture.c
    src/recv.c
    src/replay_gain.c
    src/resolver.c
    src/response.c
    src/rplaylist.c
    src/run.c
    src/search.c
    src/send.c
    src/settings.c
    src/socket.c
    src/song.c
    src/stats.c
    src/status.c
    src/sticker.c
    src/sync.c
    src/tag.c
)

=== dist/mjson/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-3.0-or-later
# myMPD (c) 2018-2022 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/mympd

add_library(mjson "")

target_sources(mjson
  PRIVATE
    mjson.c
  PUBLIC
    mjson.h
)

target_compile_options(mjson
  PRIVATE
    "-DMJSON_ENABLE_PRINT=0"
    "-DMJSON_ENABLE_BASE64=0"
    "-DMJSON_ENABLE_RPC=0"
    "-DMJSON_ENABLE_PRETTY=0"
    "-DMJSON_ENABLE_MERGE=0"
)

if(CMAKE_BUILD_TYPE MATCHES "(Release|Debug)")
  if((CMAKE_C_COMPILER_ID STREQUAL "Clang") AND (CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL "15.0.0"))
    #clang 15 compatibility
    target_compile_options(mjson
      PUBLIC
      "-Wno-unused-but-set-variable"
    )
    message("Enabling workaround for mjson and clang 15")
  endif()
endif()

=== dist/mongoose/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-3.0-or-later
# myMPD (c) 2018-2022 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/mympd

add_library(mongoose "")

target_sources(mongoose
  PRIVATE
    mongoose.c
  PUBLIC
    mongoose.h
)

target_compile_options(mongoose
  PRIVATE
    "-DMG_ENABLE_DIRECTORY_LISTING=1"
    "-DMG_ENABLE_SSI=0"
)

if(MYMPD_ENABLE_IPV6)
  message("Mongoose: IPv6 is enabled")
  target_compile_options(mongoose
    PUBLIC
      "-DMG_ENABLE_IPV6=1"
  )
else()
  message("Mongoose: IPv6 is disabled")
endif()

if(MYMPD_ENABLE_SSL)
  message("Mongoose: SSL is enabled")
  target_compile_options(mongoose
    PUBLIC
      "-DMG_ENABLE_OPENSSL=1"
  )
  target_include_directories(mongoose SYSTEM
    PRIVATE
      ${OPENSSL_INCLUDE_DIR}
  )
else()
  message("Mongoose: SSL is disabled")
endif()

=== dist/rax/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-3.0-or-later
# myMPD (c) 2018-2022 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/mympd

add_library(rax "")

target_sources(rax
  PRIVATE
    rax.c
    rax_malloc.h
  PUBLIC
    rax.h
)

target_include_directories(rax
  PRIVATE
    ${PROJECT_SOURCE_DIR}
)

if(CMAKE_BUILD_TYPE MATCHES "(Release|Debug)")
  target_compile_options(rax
    PRIVATE
      "-Wno-shadow"
      "-Wno-incompatible-pointer-types-discards-qualifiers"
  )

  if(CMAKE_C_COMPILER_ID STREQUAL "GNU")
    target_compile_options(rax
      PRIVATE
        "-Wno-discarded-qualifiers"
        "-Wno-use-after-free"
    )
  endif()
endif()

=== dist/sds/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-3.0-or-later
# myMPD (c) 2018-2022 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/mympd

add_library(sds "")

target_sources(sds
  PRIVATE
    sds.c
    sdsalloc.h
  PUBLIC
    sds.h
)

target_include_directories(sds
  PRIVATE
    ${PROJECT_SOURCE_DIR}
)

=== dist/tinymt/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-3.0-or-later
# myMPD (c) 2018-2022 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/mympd

add_library(tinymt "")

target_sources(tinymt
  PRIVATE
    tinymt32.c
  PUBLIC
    tinymt32.h
)

=== debian/changelog ===
mympd (10.1.1-1~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.
  * Modernize d/rules.

 -- Steven Pusser <stevep@mxlinux.org>  Fri, 18 Nov 2022 12:22:50 -0800

mympd (10.1.1-1) unstable; urgency=medium

  * Release from master

 -- Juergen Mang <mail@jcgames.de>  Sun, 13 Nov 2022 12:11:15 +0100

=== debian/control ===
Source: mympd
Section: sound
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Juergen Mang <mail@jcgames.de>
Build-Depends: cmake,
               debhelper-compat (= 12),
               gzip,
               jq,
               libflac-dev,
               libid3tag0-dev,
               liblua5.4-dev | liblua5.3-dev,
               libpcre2-dev,
               libssl-dev,
               perl
Standards-Version: 4.1.2
Homepage: https://jcorporation.github.io/myMPD/

Package: mympd
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: standalone, mobile friendly web-based MPD client.
 myMPD is a standalone and lightweight web-based MPD client. It's 
 tuned for minimal resource usage and requires very few dependencies.
 Therefore myMPD is ideal for Raspberry Pis and similar devices.
